'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));

function withReactHooks(OriginalComponent) {
  const actualRender = OriginalComponent.prototype.render; // If you're mad that I'm typing the result here as `any`, then please submit a PR,
  // and then immedietly close it because I don't care what you think.

  function HooksProvider(props) {
    if (!props.instance) {
      return null;
    }

    return actualRender.call(props.instance);
  } // @ts-ignore Ugh, I promise accessing displayName is fine.


  const componentName = OriginalComponent.displayName || OriginalComponent.name || 'Component';
  HooksProvider.displayName = componentName + 'Hooks';

  OriginalComponent.prototype.render = function () {
    return React.createElement(HooksProvider, {
      instance: this
    });
  };

  return OriginalComponent;
}

exports.default = withReactHooks;
